#include <stdio.h>
#include <stdlib.h>
#define NMax 100005

int n, m;

int h[NMax], o[NMax];
int q[NMax], oq[NMax];
int answer1[NMax], answer2[NMax];

int compHeight(const void *a, const void *b) {
	int va = *(int *)a;
	int vb = *(int *)b;

	if (h[va] != h[vb]) {
		return h[va] - h[vb];
	}
	return va - vb;
}

int compQuery(const void *a, const void *b) {
	return q[*(int *)a] - q[*(int *)b];
}

int main() {

	freopen("colina.in", "rt", stdin);
	freopen("colina.out", "wt", stdout);

	scanf("%d %d", &n, &m);

	for (int i = 0; i < n; i++) {
		scanf("%d", &h[i]);
		o[i] = i;
	}
	qsort(o, n, sizeof(o[0]), compHeight);

	for (int i = 0; i < m; i++) {
		scanf("%d", &q[i]);
		oq[i] = i;
	}

	qsort(oq, m, sizeof(o[0]), compQuery);

	int j = 0;
	for (int i = 0; i < m; i++) {
		// q[oq[i]] are in increasing order
		// h[o [j]] are in increasing order too

		while (h[o[j]] < q[oq[i]] && j < n) {
			j++;
		}

		if (j == n) {
			answer1[oq[i]] = 0;
		} else {
			if (q[oq[i]] == h[o[j]]) {
				answer1[oq[i]] = o[j] + 1;
				if (j + 1 < n && q[oq[i]] == h[o[j + 1]]) {
				answer2[oq[i]] = o[j + 1] + 1;
				}
			}
		}
	}

	for (int i = 0; i < m; i++) {
		if (answer1[i] == 0) {
			printf("NU\n");
		} else if (answer2[i] != 0) {
			printf("DA %d %d\n", answer1[i], answer2[i]);
		} else {
			printf("DA %d\n", answer1[i]);
		}
	}

	fclose(stdin);
	fclose(stdout);
	return 0;
}
