#include <fstream>

using namespace std;

#define NMAX 51 * 26

FILE *fin, *fout;

int n, m;
char MA[NMAX][NMAX], L[51], C[51];

void citire()
{
   int i, x, y;
   fscanf(fin, "%d %d\n", &n, &m);
   for (i = 1; i <= m; ++i)
   {
      fscanf(fin, "%d %d\n", &x, &y);
      MA[x][y] = MA[y][x] = 1;
   }
   fclose(fin);
}

void elimina_nod_i(int x)
{
   int i;
   for (i = 1; i <= n; ++i)
   {
      L[i] = MA[x][i];        //salvez linia
      C[i] = MA[i][x];        //salvez coloana
      MA[x][i] = MA[i][x] = 0;//elimin nodul i
   }
}

void refa(int x)
{
   int i;
   for (i = 1; i <= n; ++i)
   {
      MA[x][i] = L[i];        //refac linia
      MA[i][x] = C[i];        //refac coloana
   }
}

int conex(int nod)
{//verific cu BFS plecand din nodul nod daca a ramas conex
   int viz[51] = {0}, ic = 0, sc = 0, i, nrviz = 0;
   short int C[NMAX], nod1;
   C[sc] = nod;
   viz[nod] = 1; nrviz++;
   while (ic <= sc)
   {
      nod1 = C[ic++];
      for (i = 1; i <= n; ++i)
         if (!viz[i] && MA[nod1][i])
         {
            viz[i] = 1;
            nrviz++;
            C[++sc] = i;
         }
   }
   return (nrviz == n - 1);//daca au fost vizitate n-1 este conex
}

int main()
{
   int i;
   fin = fopen("cristal.in", "r");
   fout = fopen("cristal.out", "w");
   citire();
   for (i = 1; i <= n; ++i)
   {
      elimina_nod_i(i);
      if (i == 1)
      {
         if (conex(2))
            fprintf(fout, "%d ", i);
      }
      else
      {
         if (conex(1))
            fprintf(fout, "%d ", i);
      }
      refa(i);
   }
   fprintf(fout, "\n");
   fclose(fout);
   return 0;
}
