#include <fstream>
#include <cmath>
#include <iomanip>
#define EPS 0.0000001

using namespace std;
ifstream fin("grindina.in");
ofstream fout("grindina.out");
struct punct
{
    int x,y;
};

struct poligon
{
    int nrp;
    punct A[8];
    float sp;
    int nrb;
};

punct B[10001];
poligon q[1001];
int nrl,G;

void citeste(int &nr, punct P[])
{
    int i;

    fin>>nr;
    for(i=1;i<=nr;i++)
      fin>>P[i].x>>P[i].y;
}
void citestegrindina()
{int i;
     fin>>G;
    for(i=1;i<=G;i++) fin>>B[i].x>>B[i].y;
}
void afisare(int nr,punct P[])
{int i;
   for(i=1;i<=nr;i++)
      fout<<P[i].x<<" "<<P[i].y<<" ";

}
double ariat(punct P1,punct P2,punct P3)
{
    double det;

    det=P1.x*P2.y+P2.x*P3.y+P1.y*P3.x-P2.y*P3.x-P3.y*P1.x-P1.y*P2.x;

    det=fabs(det);

    return det/2.0;
}

double ariap(int nr, punct P[])
{
    int i;
    double sp=0;
    for(i=2;i<=nr-1;i++)
      sp=sp+ariat(P[1],P[i],P[i+1]);
    return sp;
}

int f(punct P,punct M1,punct M2)
{int v;
 v=(P.y-M1.y)*(M2.x-M1.x)-(P.x-M1.x)*(M2.y-M1.y);
 return v;
}

int interior(int nr,int ord,punct P)
{int ok=1,i,j,s1,s2;
float at;
 q[ord].A[nr+1]=q[ord].A[1];q[ord].A[nr+2]=q[ord].A[2];
 for(i=1;i<=nr;i++)
   {
       at=ariat(P,q[ord].A[i],q[ord].A[i+1]);
       if(fabs(at)<EPS)return 0;
   }
 for(i=1;i<=nr;i++)
   {s1=f(P,q[ord].A[i],q[ord].A[i+1]);
    for(j=i+2;j<=nr+2;j++)
      {
          s2=f(q[ord].A[j],q[ord].A[i],q[ord].A[i+1]);
          if(s1*s2<0)
            {
                ok=0;
                break;
            }
      }

   }
 return ok;
}

int nrboabe(int ord, double sp)
{
    int nrp, nrb, b;
    nrp=q[ord].nrp;
    nrb=0;
    for(b=1; b<=G; b++)
    {if(interior(nrp,ord,B[b]))
           {nrb++;
            //fout<<B[b].x<<" "<<B[b].y<<endl;
           }
    }
    return nrb;
}

void solve()
{int lot, l,lmax,nrbmax,nrmax,nrmin=0, nrpp,nrb;
 double sp;
 if(G)
   {
    lot=1;nrpp=q[1].nrp;
    sp=ariap(nrpp,q[1].A);
    nrb=nrboabe(1,sp);
    q[1].sp=sp;
    q[1].nrb=nrb;
   // fout<<"lot="<<lot<<" sp="<<sp<<" nrb="<<nrb<<'\n';
    nrbmax=nrb;lmax=1;nrmax=1;
    l=2;
    while(l<=nrl)
     {nrpp=q[l].nrp;
      sp=ariap(nrpp,q[l].A);
      q[l].sp=sp;
      nrb=nrboabe(l,sp);
      q[l].nrb=nrb;
      //fout<<"lot="<<l<<" sp="<<sp<<" nrb="<<nrb<<'\n';
      if(nrb>nrbmax)
        {lmax=l;nrmax=1;
         nrbmax=nrb;
        }
      else if(nrb==nrbmax) nrmax++;
      l++;
     }
   // fout<<"nrbmax="<<nrbmax<<'\n';
    //fout<<"lot max="<<lmax<<'\n';
    fout<<nrmax<<'\n';
    for(l=1;l<=nrl;l++)
     {if(q[l].nrb==nrbmax)
       fout<<l<<' ';
      if(q[l].nrb==0)nrmin++;
     }
    fout<<'\n';
    fout<<nrmin<<'\n';
    if(nrmin==0)fout<<0<<'\n';
    else
     for(l=1;l<=nrl;l++)
      {if(q[l].nrb==0)
       fout<<l<<' ';
      }
   }
  else
     {fout<<nrl<<'\n';
      for(l=1;l<=nrl;l++)
       fout<<l<<' ';
      fout<<'\n';
       fout<<nrl<<'\n';
      for(l=1;l<=nrl;l++)
       fout<<l<<' ';
     }

}
int main()
{int l;
 fin>>nrl;
 for(l=1;l<=nrl;l++)
    citeste(q[l].nrp,q[l].A);
 citestegrindina();
 solve();

 fin.close();
 fout.close();
 return 0;
}
