//prof. Marinel Serban
//decembrie 2013
#include <fstream>
#include <cstring>
#include <cmath>

using namespace std;

#define DIM 100

struct cuvant
{
    char cuv[40];
    short int lin, col;
    char tip;
};

cuvant cuvinte[5000];   //aici retin cuvintele pe care le sortez (direct?)

char a[DIM * DIM + 1];
char x[DIM + 1][DIM + 1];
short int i, j, nrcuv, nr;
short int n, l[DIM], c[DIM], nrd;

ifstream fin ("rebus.in");
ofstream fout ("rebus.out");

void citire()
{
    char car;
    fin >> nrcuv;
    fin.get (car);
    fin.getline (a, DIM * DIM + 1);
    fin.close();
    n = strlen (a);
}

void calcdiv (int n)
{   //determin dimesiunile posibile ale careului
    int d, rad = sqrt ((double)(n));
    nrd = 0;
    for (d = 2; d <= rad; d++)
        if (n % d == 0)
        {
            nrd++;
            l[nrd] = d;
            c[nrd] = n / d;
            nrd++;
            l[nrd] = n / d;
            c[nrd] = d;
        }
}

void fa_rebus (short int lin, short int col)
{
    short int i, j;
    for (i = 1; i <= lin; i++)                  //formez careul
        for (j = 1; j <= col; j++)
            x[i][j] = a[ (i - 1) * col + j - 1];

    /*
        fout << lin << ' ' << col << '\n';
        for (i = 1; i <= lin; i++)
        {
            for (j = 1; j <= col; j++)
                fout << x[i][j];
            fout << '\n';
        }
        fout << '\n';
    */
}

short int numara (short int caz)
{
    short int nr = 0, i, j, lung = 0, k;

    for (i = 1; i <= l[caz]; i++)                //NUMAR CUVINTE PE LINII
    {
        lung = 0;
        j = 1;
        while (x[i][j] == ' ') j++;
        while (j <= c[caz])
        {
            while (j <= c[caz] && x[i][j] != ' ')
            {
                lung++;
                j++;
            }
            if (lung > 1)
            {
                nr++;
                cuvinte[nr].tip = 'O';
                cuvinte[nr].lin = i;
                cuvinte[nr].col = j - lung;
                for (k = j - lung; k < j; k++)
                    cuvinte[nr].cuv[k - j + lung] = x[i][k];
                cuvinte[nr].cuv[k - j + lung] = 0;
            }
            if (x[i][j] == ' ')
            {
                lung = 0;
                j++;
            }
        }
    }
//    fout << "ORIZONTAL: " << nr <<' ';
    for (j = 1; j <= c[caz]; j++)            //NUMAR CUVINTE PE COLOANE
    {
        lung = 0;
        i = 1;
        while (x[i][j] == ' ') i++;
        while (i <= l[caz])
        {
            while (i <= l[caz] && x[i][j] != ' ')
            {
                lung++;
                i++;
            }
            if (lung > 1)
            {
                nr++;
                cuvinte[nr].tip = 'V';
                cuvinte[nr].lin = i - lung;
                cuvinte[nr].col = j;
                for (k = i - lung; k < i; k++)
                    cuvinte[nr].cuv[k - i + lung] = x[k][j];
                cuvinte[nr].cuv[k - i + lung] = 0;
            }
            if (x[i][j] == ' ')
            {
                lung = 0;
                i++;
            }
        }
    }
//  fout << "TOTAL: " << nr << '\n';
    return nr;
}

void schimba(int i, int j)
{
    cuvant aux;
    aux = cuvinte[i];
    cuvinte[i] = cuvinte[j];
    cuvinte[j] = aux;
}

void solutie (short int caz)
{
    short int i, j;
    for (i = 1; i < nr; i++)                              //sortez cuvintele
        for (j = i + 1; j <= nr; j++)
            if (strcmp (cuvinte[i].cuv, cuvinte[j].cuv) > 0)
                schimba(i, j);        //cuvinte distincte
            else
                if (strcmp (cuvinte[i].cuv, cuvinte[j].cuv) == 0)
                {                     //cuvinte egale
                    if (cuvinte[i].lin > cuvinte[j].lin) //ordonez dupa linii
                        schimba(i, j);
                    else
                        if (cuvinte[i].lin == cuvinte[j].lin)
                        {             //si linii egale
                            if (cuvinte[i].col > cuvinte[j].col)
                                schimba(i, j); //ordonez dupa coloane
                            else
                                if (cuvinte[i].col == cuvinte[j].col)
                                {     //si coloane egale
                                    if (cuvinte[i].tip > cuvinte[j].tip)
                                        schimba(i, j); //ordonez dupa tip
                                }
                        }
                }
    fout << l[caz] << ' ' << c[caz] << '\n';              //afisez solutia
    for (i = 1; i <= nr; i++)
        fout << cuvinte[i].cuv << ' ' << cuvinte[i].lin << ' ' << cuvinte[i].col << ' ' << cuvinte[i].tip << '\n';
//    fout << '\n';
    fout.close();
}

int main()
{
    short int caz;
    citire();
    calcdiv (n);
    for (caz = 1; caz <= nrd; caz++)
        if (l[caz] <= 100 && c[caz] <= 100)          //daca sunt dimesiuni corecte
        {
            memset (cuvinte, sizeof (cuvinte), 0);   //curata vectorul de cuvinte
            fa_rebus (l[caz], c[caz]);               //construieste careul
            nr = numara (caz);                       //numara cuvintele
            if (nr == nrcuv)             //am gasit solutia
            {
                solutie (caz);
                return 0;
            }
        }
//    return 0;
}
