//verif rebus marinel
#include <fstream>
#include <iostream>
#include <cstdlib>
#include <cstring>
using namespace std;

ifstream fok("rebus.ok");
ifstream fout("rebus.out");

void Msg(int pct, string msg);
void schimba(int i, int j);

struct cuvant
{
    char cuv[40];
    short int lin, col;
    char tip;
};

cuvant cuvinte_OUT[5000], cuvinte_OK[5000];
int schimbari, diferente, nrcuv_OK, nrcuv_OUT;

int main(int argc, char* argv[])
{
    if (!fout)
        Msg(0, "Nu exista fisierul rebus.out!");

    int testNumber = 0, testPoints = 10;

	testNumber =  atoi(argv[1]); // numarul testului
	testPoints =  atoi(argv[2]); // nr puncte/test

    int total = 0, t1 = 0, t2 = 0, t3 = 0;// punctajul total
    bool ok1 = false, ok2 = false, ok3 = false;

	// trei cerinte
    int a, b;     // valori corecte linii/coloane
    int x, y;     // valorile concurentului linii/coloane
	fok >> a >> b; fok.get();
	fout >> x >> y; fout.get();

	if ( a == x && b == y)
    {
        t1= (testPoints * 20) / 100;  // 20 % din punctajul pe test
        ok1 = true;
    }

//citesc cuvintele OK
    while (!fok.eof())
    {
        nrcuv_OK++;
        fok >> cuvinte_OK[nrcuv_OK].cuv;
        fok >> cuvinte_OK[nrcuv_OK].lin;
        fok >> cuvinte_OK[nrcuv_OK].col;
        fok.get();
        fok.get(cuvinte_OK[nrcuv_OK].tip);
    }
    nrcuv_OK--;
//citesc cuvintele OUT
    while (!fout.eof())
    {
        nrcuv_OUT++;
        fout >> cuvinte_OUT[nrcuv_OUT].cuv;
        fout >> cuvinte_OUT[nrcuv_OUT].lin;
        fout >> cuvinte_OUT[nrcuv_OUT].col;
        fout.get();
        fout.get(cuvinte_OUT[nrcuv_OUT].tip);
    }
    nrcuv_OUT--;
//sortez cuvintele OUT si retin numarul de schimbari
    schimbari = 0;
    int i, j;
    for (i = 1; i < nrcuv_OUT; i++)                              //sortez cuvintele
        for (j = i + 1; j <= nrcuv_OUT; j++)
            if (strcmp (cuvinte_OUT[i].cuv, cuvinte_OUT[j].cuv) > 0)
                schimba(i, j);        //cuvinte distincte
            else
                if (strcmp (cuvinte_OUT[i].cuv, cuvinte_OUT[j].cuv) == 0)
                {                     //cuvinte egale
                    if (cuvinte_OUT[i].lin > cuvinte_OUT[j].lin) //ordonez dupa linii
                        schimba(i, j);
                    else
                        if (cuvinte_OUT[i].lin == cuvinte_OUT[j].lin)
                        {             //si linii egale
                            if (cuvinte_OUT[i].col > cuvinte_OUT[j].col)
                                schimba(i, j); //ordonez dupa coloane
                            else
                                if (cuvinte_OUT[i].col == cuvinte_OUT[j].col)
                                {     //si coloane egale
                                    if (cuvinte_OUT[i].tip > cuvinte_OUT[j].tip)
                                        schimba(i, j); //ordonez dupa tip
                                }
                        }
                }
    diferente = 0;
    if (nrcuv_OK == nrcuv_OUT)
        for (i = 1; i <= nrcuv_OK; i++)
            if ((strcmp(cuvinte_OK[i].cuv, cuvinte_OUT[i].cuv) != 0) ||
                (cuvinte_OK[i].lin != cuvinte_OUT[i].lin) ||
                (cuvinte_OK[i].col != cuvinte_OUT[i].col) ||
                (cuvinte_OK[i].tip != cuvinte_OUT[i].tip))
                    diferente++;
//verific daca sunt toate cuvintele
    if (nrcuv_OUT == nrcuv_OK && diferente == 0)
    //cuvinele sunt toate si corecte
        {
            if (schimbari == 0)
            {
                t2= (testPoints * 40) / 100; // 40 % din punctaj
                ok2 = true;
                t3= (testPoints * 40) / 100; // 40 % din punctaj
                ok3 = true;
            }
            else
            {
                t2= (testPoints * 40) / 100; // 40 % din punctaj
                ok2 = true;
                ok3 = false;
                t3 = 0;
            }
        }

    if ( ok1 && ok2 && ok3 )
       Msg(t1 + t2 + t3, "Corect !");
    if (!ok1 && !ok2 && !ok3)
        Msg(total, "Incorect !" );
    if (ok1 && ok2)
        Msg(t1 + t2, "Cuvintele nu sunt sortate!");
    if (ok1)
        Msg(t1, "Lista cuvinte incorecta !");
    return 0;
}

void Msg(int pct, string msg )
{
    cout << pct << ' ' << msg;
    try
    {
        fok.close();
        fout.close();
    }
    catch (string ex) {}
    exit(0);
}

void schimba(int i, int j)
{
    cuvant aux;
    aux = cuvinte_OUT[i];
    cuvinte_OUT[i] = cuvinte_OUT[j];
    cuvinte_OUT[j] = aux;
    schimbari++;
}
